// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from tuw_multi_robot_msgs:msg/RoutePrecondition.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PRECONDITION__FUNCTIONS_H_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PRECONDITION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "tuw_multi_robot_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "tuw_multi_robot_msgs/msg/detail/route_precondition__struct.h"

/// Initialize msg/RoutePrecondition message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_multi_robot_msgs__msg__RoutePrecondition
 * )) before or use
 * tuw_multi_robot_msgs__msg__RoutePrecondition__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__msg__RoutePrecondition__init(tuw_multi_robot_msgs__msg__RoutePrecondition * msg);

/// Finalize msg/RoutePrecondition message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__msg__RoutePrecondition__fini(tuw_multi_robot_msgs__msg__RoutePrecondition * msg);

/// Create msg/RoutePrecondition message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_multi_robot_msgs__msg__RoutePrecondition__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__msg__RoutePrecondition *
tuw_multi_robot_msgs__msg__RoutePrecondition__create();

/// Destroy msg/RoutePrecondition message.
/**
 * It calls
 * tuw_multi_robot_msgs__msg__RoutePrecondition__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__msg__RoutePrecondition__destroy(tuw_multi_robot_msgs__msg__RoutePrecondition * msg);

/// Check for msg/RoutePrecondition message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__msg__RoutePrecondition__are_equal(const tuw_multi_robot_msgs__msg__RoutePrecondition * lhs, const tuw_multi_robot_msgs__msg__RoutePrecondition * rhs);

/// Copy a msg/RoutePrecondition message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__msg__RoutePrecondition__copy(
  const tuw_multi_robot_msgs__msg__RoutePrecondition * input,
  tuw_multi_robot_msgs__msg__RoutePrecondition * output);

/// Initialize array of msg/RoutePrecondition messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_multi_robot_msgs__msg__RoutePrecondition__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__init(tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * array, size_t size);

/// Finalize array of msg/RoutePrecondition messages.
/**
 * It calls
 * tuw_multi_robot_msgs__msg__RoutePrecondition__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__fini(tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * array);

/// Create array of msg/RoutePrecondition messages.
/**
 * It allocates the memory for the array and calls
 * tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence *
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__create(size_t size);

/// Destroy array of msg/RoutePrecondition messages.
/**
 * It calls
 * tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__destroy(tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * array);

/// Check for msg/RoutePrecondition message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__are_equal(const tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * lhs, const tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * rhs);

/// Copy an array of msg/RoutePrecondition messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence__copy(
  const tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * input,
  tuw_multi_robot_msgs__msg__RoutePrecondition__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PRECONDITION__FUNCTIONS_H_
