// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_multi_robot_msgs:msg/RouteProgress.idl
// generated code does not contain a copyright notice
#include "tuw_multi_robot_msgs/msg/detail/route_progress__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `passed`
// Member `todo`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
tuw_multi_robot_msgs__msg__RouteProgress__init(tuw_multi_robot_msgs__msg__RouteProgress * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    tuw_multi_robot_msgs__msg__RouteProgress__fini(msg);
    return false;
  }
  // passed
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->passed, 0)) {
    tuw_multi_robot_msgs__msg__RouteProgress__fini(msg);
    return false;
  }
  // current
  // todo
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->todo, 0)) {
    tuw_multi_robot_msgs__msg__RouteProgress__fini(msg);
    return false;
  }
  // progress
  return true;
}

void
tuw_multi_robot_msgs__msg__RouteProgress__fini(tuw_multi_robot_msgs__msg__RouteProgress * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // passed
  rosidl_runtime_c__int32__Sequence__fini(&msg->passed);
  // current
  // todo
  rosidl_runtime_c__int32__Sequence__fini(&msg->todo);
  // progress
}

bool
tuw_multi_robot_msgs__msg__RouteProgress__are_equal(const tuw_multi_robot_msgs__msg__RouteProgress * lhs, const tuw_multi_robot_msgs__msg__RouteProgress * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // passed
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->passed), &(rhs->passed)))
  {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // todo
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->todo), &(rhs->todo)))
  {
    return false;
  }
  // progress
  if (lhs->progress != rhs->progress) {
    return false;
  }
  return true;
}

bool
tuw_multi_robot_msgs__msg__RouteProgress__copy(
  const tuw_multi_robot_msgs__msg__RouteProgress * input,
  tuw_multi_robot_msgs__msg__RouteProgress * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // passed
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->passed), &(output->passed)))
  {
    return false;
  }
  // current
  output->current = input->current;
  // todo
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->todo), &(output->todo)))
  {
    return false;
  }
  // progress
  output->progress = input->progress;
  return true;
}

tuw_multi_robot_msgs__msg__RouteProgress *
tuw_multi_robot_msgs__msg__RouteProgress__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__RouteProgress * msg = (tuw_multi_robot_msgs__msg__RouteProgress *)allocator.allocate(sizeof(tuw_multi_robot_msgs__msg__RouteProgress), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_multi_robot_msgs__msg__RouteProgress));
  bool success = tuw_multi_robot_msgs__msg__RouteProgress__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_multi_robot_msgs__msg__RouteProgress__destroy(tuw_multi_robot_msgs__msg__RouteProgress * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_multi_robot_msgs__msg__RouteProgress__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_multi_robot_msgs__msg__RouteProgress__Sequence__init(tuw_multi_robot_msgs__msg__RouteProgress__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__RouteProgress * data = NULL;

  if (size) {
    data = (tuw_multi_robot_msgs__msg__RouteProgress *)allocator.zero_allocate(size, sizeof(tuw_multi_robot_msgs__msg__RouteProgress), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_multi_robot_msgs__msg__RouteProgress__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_multi_robot_msgs__msg__RouteProgress__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_multi_robot_msgs__msg__RouteProgress__Sequence__fini(tuw_multi_robot_msgs__msg__RouteProgress__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_multi_robot_msgs__msg__RouteProgress__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_multi_robot_msgs__msg__RouteProgress__Sequence *
tuw_multi_robot_msgs__msg__RouteProgress__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__RouteProgress__Sequence * array = (tuw_multi_robot_msgs__msg__RouteProgress__Sequence *)allocator.allocate(sizeof(tuw_multi_robot_msgs__msg__RouteProgress__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_multi_robot_msgs__msg__RouteProgress__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_multi_robot_msgs__msg__RouteProgress__Sequence__destroy(tuw_multi_robot_msgs__msg__RouteProgress__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_multi_robot_msgs__msg__RouteProgress__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_multi_robot_msgs__msg__RouteProgress__Sequence__are_equal(const tuw_multi_robot_msgs__msg__RouteProgress__Sequence * lhs, const tuw_multi_robot_msgs__msg__RouteProgress__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_multi_robot_msgs__msg__RouteProgress__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_multi_robot_msgs__msg__RouteProgress__Sequence__copy(
  const tuw_multi_robot_msgs__msg__RouteProgress__Sequence * input,
  tuw_multi_robot_msgs__msg__RouteProgress__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_multi_robot_msgs__msg__RouteProgress);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_multi_robot_msgs__msg__RouteProgress * data =
      (tuw_multi_robot_msgs__msg__RouteProgress *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_multi_robot_msgs__msg__RouteProgress__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_multi_robot_msgs__msg__RouteProgress__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_multi_robot_msgs__msg__RouteProgress__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
